//$Log: capiisdnmon.h,v $
//Revision 1.4  2005/01/30 23:55:40  tubsmaster
//- log file gets flushed every start
//- check if /dev/capi20 is writeable and readable
//
//Revision 1.3  2005/01/30 16:59:59  tubsmaster
//now we have ldap support for addressresolution
//

#ifndef CAPIISDNMON_H
#define CAPIISDNMON_H


#include <iostream>
#include <string>

#include "capithread.h"
#include "xosddisplay.h"
#include "ldapaddressbook.h"
#include "logger.h"

/**
* does the historing stuff - helper class.
* very primitive...
*/
class capiIsdnMonHist
{
public:
	bool prepareLogFile(std::string HistFile);
	bool addCall(std::string Number,std::string Caller);
private:
	std::string HistFile;
};

/**
* does the config file stuff
* holds the ldap config variables
*/
class capiIsdnMonConfig
{
public:
	capiIsdnMonConfig(std::string configFile) {_configFile=configFile;}
	std::string getLdapHostname(){return _ldapHostname;}
	std::string getLdapPort(){return _ldapPort;}
	std::string getLdapBase(){return _ldapBase;}
	std::string getWantLdap(){return _wantLdap;}
	
	void setLdapHostname(std::string ldapHostname){ _ldapHostname=ldapHostname;}
	void setLdapPort(std::string ldapPort){_ldapPort=ldapPort;}
	void setLdapBase(std::string ldapBase){_ldapBase=ldapBase;}
	void setWantLdap(std::string wantLdap){_wantLdap=wantLdap;}

	bool writeConfigToFile();
	bool readConfigFile();
private:
	std::string _wantLdap;
	std::string _configFile;
	std::string _ldapHostname;
	std::string _ldapPort;
	std::string _ldapBase;			       
};


/**
* The main class. Does specific stuff for capiIsdnMon application.
* Holds all Classes und coordinates the program-flow.
*/
class capiIsdnMon
{

public:
	capiIsdnMon();
	~capiIsdnMon();
	void stopThreadAndQuit();
	void showNumber(std::string number);
	void capiIsdnMon::initLdap();
	
	capiIsdnMonConfig * _capiIsdnMonConfig;
	ldapAddressServer * _ldapAddressServer;
	Logger * capiIsdnMonLogger;

private:

	std::string fullCapiIsdnMonPath;
	
        capiThread * _capiThread;
	xosdDisplay * _xosdDisplay;

	capiIsdnMonHist myCapiIsdnMonHist;

	std::string _number;
	bool _newNumberFlag;
	bool haveValidHistFile;
		    
};


#endif
