//$Log: capithread.cpp,v $
//Revision 1.4  2005/01/30 23:55:40  tubsmaster
//- log file gets flushed every start
//- check if /dev/capi20 is writeable and readable
//
//Revision 1.3  2005/01/30 16:59:59  tubsmaster
//now we have ldap support for addressresolution
//
//Revision 1.2  2004/10/20 18:28:35  tubsmaster
//no more warnings..
//
//Revision 1.1.1.1  2004/06/17 07:17:37  tubsmaster
//initial gtk version
//
//Revision 1.1.1.1  2004/06/05 12:43:28  tubsmaster
//First gtk release
//
//Revision 1.1.1.1  2004/05/21 13:10:39  tubsmaster
//Initial import.
//
//Revision 1.7  2004/05/20 09:15:38  tubsmaster
//add doxygen doc
//

static const char capithread_cpp[] = "$Id: capithread.cpp,v 1.4 2005/01/30 23:55:40 tubsmaster Exp $";

#include <iostream>

#include "capithread.h"
#include "capiinfo.h"
#include "capiisdnmon.h"

using namespace std;

/**
* Constructor, needed for bidirectional communication.
*/
capiThread::capiThread(void * _capiIsdnMon)
{
  uglycapiIsdnMon = _capiIsdnMon;	
}

/**
* Construct to simulate a thread class
*/
void capiThread::run()
{
	pthread_create(&_thread,NULL,(void *(*)(void *))&capiThread::_run ,this);
}

/**
* The capiThread loop.
* inititializes the capi and waits for call in an endless loop.
* no method is allowed here, so we have a dirty static class function hack
* @param _capiThread the capiThread, so we can call the real method.
*/
void  capiThread::_run(capiThread &_capiThread)
{
	_capiThread.realrun();
}

/**
* Construct to simulate a thread class (..pthread issues..)
*/
void  capiThread::realrun()
{
#ifdef DEBUG	    
    std::cout << "begin of run()" << std::endl;
#endif		
    _stop = false;
    try
    {
	capiInfo _capiInfo;
	std::string myString;
	((capiIsdnMon*)uglycapiIsdnMon)->capiIsdnMonLogger->addToLog("CAPI Stuff ready...");
	while (_stop == false)
	{
	    myString = _capiInfo.waitForCall(1);
	    if (myString != "NULL")
	    {
#ifdef DEBUG	    
		std::cout << myString << std::endl;
#endif		
		((capiIsdnMon*)uglycapiIsdnMon)->showNumber(myString);
	    }
	}
    }
    catch(capiError _capiError)
    {
        ((capiIsdnMon*)uglycapiIsdnMon)->capiIsdnMonLogger->addToLog(_capiError.getErrorText());
	cout << "Fatal Error: " << _capiError.getErrorText() << endl;
	exit(2);
    }
#ifdef DEBUG	    
    std::cout << "end of run()" << std::endl;
#endif		
}


/**
* stops the capi endless loop.
* using this method is the cleanest way to stop capi stuff.
*/
void capiThread::stopThread()
{
#ifdef DEBUG
    std::cout << "stopthread()";
#endif
    _stop = true;
}

/**
* waits for thread to end.
*/
void capiThread::waitForThreadEnd()
{
  pthread_join(_thread,NULL);  
}
