#if HAVE_CONFIG_H
#include <config.h>
#endif
#include "gtkdocklet.h"
#include "icon1.xpm"
#include "icon2.xpm"
#include <string>

static const char gtkdocklet_cpp[] = "$Id: gtkdocklet.cpp,v 1.7 2005/01/30 16:59:59 tubsmaster Exp $";

struct capiIsdnMonDocklet cIMD;


bool gtk_docklet_init( capiIsdnMon * myCapiIsdnMon)  
{
  cIMD._capiIsdnMon = myCapiIsdnMon;
  cIMD._recentCounter = 0;
  cIMD.docklet = NULL;
  for (int i = 0; i < RECENT_MAX; i++)
   cIMD.recentLines[i] = "NULL";
  return true;
}

/**
* loads docklet and loads the menu if clicked
*/
bool gtk_docklet_load()
{
 if(cIMD.docklet != NULL)
    {
      //g_warning("gj_gtk_docklet_load: not loading docklet, it is already loaded.");
      return FALSE;
    }

  cIMD.docklet = egg_tray_icon_new("cIMD");
  cIMD.box = gtk_event_box_new();
  cIMD.image = gtk_image_new();
  
  gint w = 0;
  gint h = 0;

  GdkPixbuf *pb = NULL;
  //GdkPixbuf *pb_scaled = NULL;

  pb = gdk_pixbuf_new_from_xpm_data((const char **)icon1_xpm);
  /* get size */
  gtk_icon_size_lookup(GTK_ICON_SIZE_LARGE_TOOLBAR, &w, &h);
  /* scale the image */
  cIMD.pb_scaled = gdk_pixbuf_scale_simple(pb, w, h, GDK_INTERP_BILINEAR);
  /* set the image */
  gtk_image_set_from_pixbuf(GTK_IMAGE(cIMD.image), cIMD.pb_scaled);
  
  
  pb = gdk_pixbuf_new_from_xpm_data((const char **)icon2_xpm);
    /* get size */
  gtk_icon_size_lookup(GTK_ICON_SIZE_LARGE_TOOLBAR, &w, &h);
  /* scale the image */
  cIMD.pb_scaled2 = gdk_pixbuf_scale_simple(pb, w, h, GDK_INTERP_BILINEAR);

  /* clean up */
  g_object_unref(G_OBJECT(pb));


  gtk_container_add(GTK_CONTAINER(cIMD.box), cIMD.image);
  gtk_container_add(GTK_CONTAINER(cIMD.docklet), cIMD.box);
  gtk_widget_show_all(GTK_WIDGET(cIMD.docklet));
  cIMD.iconLoaded = 1;
  cIMD.iconWanted = 1;

  /* hook up signals */
  g_signal_connect(G_OBJECT(cIMD.box), "button-press-event",G_CALLBACK(gtk_docklet_clicked), NULL);


  /* ref the docklet before we bandy it about the place */
  g_object_ref(G_OBJECT(cIMD.docklet));

  return TRUE;
}

/**
* unloads the docklet...
*/
bool gtk_docklet_unload()
{
  if(cIMD.docklet == NULL)
    {
      //g_warning("gtk_docklet_load: not unloading docklet, it is already unloaded.");
      return FALSE;
    }
  g_object_unref(G_OBJECT(cIMD.docklet));
  gtk_widget_destroy(cIMD.box);

  cIMD.docklet = NULL;
  cIMD.box = NULL;
  cIMD.image = NULL;

  return TRUE;

}


/**
* Menu callback function.
* Handles clicks from the rightclick-Menu.
*/
void gtk_docklet_menu_cb(GtkMenuItem *menuitem, gpointer user_data)
{
    gint callback_action = -1;

  if(user_data == NULL)
    {
      g_warning("gtk_docklet_menu_cb: user data was NULL");
      return;
    }

  /* get action */
  callback_action = GPOINTER_TO_INT(user_data);

  //g_message ("gtk_docklet_menu_cb: agent menu activated menuitem:0x%.8x, callback action:%d",(gint)menuitem, callback_action);

     
   std::string aboutText;
   aboutText = std::string(PACKAGE_NAME) + std::string("  ") + std::string(PACKAGE_VERSION) + std::string("\nAuthor: ") + std::string(PACKAGE_BUGREPORT);
  switch(callback_action)
    {
    //about was clicked
    case 1:
   /* Create the widgets */
   GtkWidget *dialog, *label;
   dialog = gtk_dialog_new_with_buttons ("About",
                                         NULL,
                                         GTK_DIALOG_DESTROY_WITH_PARENT,
                                         GTK_STOCK_OK,
                                         GTK_RESPONSE_NONE,
                                         NULL);

   label = gtk_label_new (aboutText.c_str());
   
   /* Ensure that the dialog box is destroyed when the user responds. */
   g_signal_connect_swapped (GTK_OBJECT (dialog), 
                             "response", 
                             G_CALLBACK (gtk_widget_destroy),
                             GTK_OBJECT (dialog));

   /* Add the label, and show everything we've added to the dialog. */
   gtk_container_add (GTK_CONTAINER (GTK_DIALOG(dialog)->vbox), label);
   gtk_widget_show_all (dialog);


      break;
    // quit was clicked
    case 2: 
	//  g_message ("quit");
	  gtk_main_quit();
      break;
    case 3:
        //setting menu
        GtkWidget *settings_window;
	GtkWidget  *ldap_server_entry, *ldap_server_label;
	GtkWidget  *ldap_port_entry, *ldap_port_label;
	GtkWidget  *ldap_base_entry, *ldap_base_label;
	GtkWidget  *ldap_want_check;

	//create window
	settings_window = gtk_dialog_new_with_buttons ("Settings", NULL, GTK_DIALOG_DESTROY_WITH_PARENT,
                                         GTK_STOCK_OK, GTK_RESPONSE_ACCEPT,
					 GTK_STOCK_CANCEL, GTK_RESPONSE_CLOSE,
                                         NULL);
	

	//The TextEntrie Values are read from config
	//checkbox: status (clicked or not) is read from config
	ldap_want_check = gtk_check_button_new_with_label ("Activate Ldap Support");
	bool wantLdap = false;
	if (cIMD._capiIsdnMon->_capiIsdnMonConfig->getWantLdap()=="true")
	{
	  wantLdap=true;
	  gtk_toggle_button_set_active((GtkToggleButton *) ldap_want_check, TRUE);
	}

	//ldap hostname field
        ldap_server_label = gtk_label_new ("ldap server:");
	ldap_server_entry = gtk_entry_new_with_max_length(50);
	if (!wantLdap) gtk_widget_set_sensitive(ldap_server_entry, FALSE);
	gtk_entry_set_text(GTK_ENTRY(ldap_server_entry),cIMD._capiIsdnMon->_capiIsdnMonConfig->getLdapHostname().c_str());
	//ldap port field
        ldap_port_label = gtk_label_new ("ldap port:");
	ldap_port_entry = gtk_entry_new_with_max_length(5);
	if (!wantLdap) gtk_widget_set_sensitive(ldap_port_entry, FALSE);
	gtk_entry_set_text(GTK_ENTRY(ldap_port_entry),cIMD._capiIsdnMon->_capiIsdnMonConfig->getLdapPort().c_str());
	//ldap base field
        ldap_base_label = gtk_label_new ("ldap Base:");
	ldap_base_entry = gtk_entry_new_with_max_length(50);
	if (!wantLdap) gtk_widget_set_sensitive(ldap_base_entry, FALSE);
	gtk_entry_set_text(GTK_ENTRY(ldap_base_entry),cIMD._capiIsdnMon->_capiIsdnMonConfig->getLdapBase().c_str());
	//add to window	    
	gtk_container_add (GTK_CONTAINER (GTK_DIALOG(settings_window)->vbox), ldap_want_check);
	gtk_container_add (GTK_CONTAINER (GTK_DIALOG(settings_window)->vbox), ldap_server_label);
	gtk_container_add (GTK_CONTAINER (GTK_DIALOG(settings_window)->vbox), ldap_server_entry);
	gtk_container_add (GTK_CONTAINER (GTK_DIALOG(settings_window)->vbox), ldap_port_label);
	gtk_container_add (GTK_CONTAINER (GTK_DIALOG(settings_window)->vbox), ldap_port_entry);
	gtk_container_add (GTK_CONTAINER (GTK_DIALOG(settings_window)->vbox), ldap_base_label);
	gtk_container_add (GTK_CONTAINER (GTK_DIALOG(settings_window)->vbox), ldap_base_entry);


	//evil hack, we need the gtk_entries int the g_signal_connect function
	gpointer entries[4];
	entries[0] = ldap_want_check;
	entries[1] = ldap_server_entry;
	entries[2] = ldap_port_entry;
	entries[3] = ldap_base_entry;
	//function, which is called if ldap activate checkbox is toggled
        g_signal_connect (G_OBJECT (ldap_want_check), "toggled", G_CALLBACK (ldap_want_check_clicked), (gpointer *) entries);
	
        gtk_widget_show_all (settings_window);
	
	gint result = gtk_dialog_run (GTK_DIALOG (settings_window));
	//OK was pressed, so set new config and reconfigure ldap connection
        if (result == GTK_RESPONSE_ACCEPT)
	{
	 std::string ldapWantStr("false");
	 if (gtk_toggle_button_get_active ((GtkToggleButton*)ldap_want_check))
	     ldapWantStr = "true";
	 else
	     ldapWantStr = "false";
	 cIMD._capiIsdnMon->_capiIsdnMonConfig->setWantLdap(ldapWantStr);
	 
	 std::string ldaphostStr(gtk_entry_get_text((GtkEntry *) ldap_server_entry));
	 cIMD._capiIsdnMon->_capiIsdnMonConfig->setLdapHostname(ldaphostStr);
	 std::string ldapPortStr(gtk_entry_get_text((GtkEntry *) ldap_port_entry));
	 cIMD._capiIsdnMon->_capiIsdnMonConfig->setLdapPort(ldapPortStr);
	 std::string ldapBaseStr(gtk_entry_get_text((GtkEntry *) ldap_base_entry));
	 cIMD._capiIsdnMon->_capiIsdnMonConfig->setLdapBase(ldapBaseStr);
	 cIMD._capiIsdnMon->_capiIsdnMonConfig->writeConfigToFile();

	 if (cIMD._capiIsdnMon->_ldapAddressServer != NULL)
         {
	     delete cIMD._capiIsdnMon->_ldapAddressServer;
	     cIMD._capiIsdnMon->_ldapAddressServer = NULL;
	 }

	 if (ldapWantStr == "true")
	 {
	     cIMD._capiIsdnMon->initLdap();
	 }
	}
        gtk_widget_destroy (settings_window);
    }
}

/**
* activate-ldap-togglebox callback function.
* inactivates fields if ldap is not wanted.
*/
void ldap_want_check_clicked(GtkWidget *checkbutton, GtkWidget* *entries)
{
	if (gtk_toggle_button_get_active ((GtkToggleButton*)entries[0]))
	{
	   gtk_widget_set_sensitive(entries[1], TRUE);
	   gtk_widget_set_sensitive(entries[2], TRUE);
	   gtk_widget_set_sensitive(entries[3], TRUE);
	}
	else
	{
	   gtk_widget_set_sensitive(entries[1], FALSE);
	   gtk_widget_set_sensitive(entries[2], FALSE);
	   gtk_widget_set_sensitive(entries[3], FALSE);
	}
}

void gtk_docklet_toggleIconTrigger(int no)
{
  cIMD.iconWanted = no;
}


/**
* Docklet callback function.
* Generates rightclick-Menu.
*/
void gtk_docklet_clicked(GtkWidget *button, GdkEventButton *event, void *data)
{
   //g_message("gtk_docklet_clicked: docklet clicked");
   if(event->button == 3)
    {
      /* show the menu */
     GtkWidget *menu = NULL;

     if(event == NULL)
     {
       g_warning("gj_gtk_docklet_generate_mnu_rightclick: gdk event was NULL");
       return;
     }

    menu = gtk_menu_new();
    for (int i = 0; i < RECENT_MAX; i++)
    {
      if (cIMD.recentLines[(i + cIMD._recentCounter) % RECENT_MAX] != "NULL")
	{
	  GtkWidget * _item = gtk_menu_item_new_with_label (cIMD.recentLines[(i + cIMD._recentCounter) % RECENT_MAX].c_str());
	  gtk_menu_shell_append (GTK_MENU_SHELL (menu), _item);
	  
	}
    }
    GtkWidget * _item = gtk_separator_menu_item_new();
    gtk_menu_shell_append(GTK_MENU_SHELL(menu), _item);
    
    GtkWidget * ldap_settings_item = gtk_menu_item_new_with_label ("Ldap Settings");
    GtkWidget * about_item = gtk_menu_item_new_with_label ("About");
    GtkWidget * quit_item = gtk_menu_item_new_with_label ("Quit");
  
    gtk_menu_shell_append (GTK_MENU_SHELL (menu), ldap_settings_item);
    gtk_menu_shell_append (GTK_MENU_SHELL (menu), about_item);
    gtk_menu_shell_append (GTK_MENU_SHELL (menu), quit_item);
  
    gtk_signal_connect (GTK_OBJECT (about_item), "activate", GTK_SIGNAL_FUNC(gtk_docklet_menu_cb),
                      GINT_TO_POINTER(1));
  
    gtk_signal_connect (GTK_OBJECT (quit_item), "activate", GTK_SIGNAL_FUNC(gtk_docklet_menu_cb),
                      GINT_TO_POINTER(2));
    
    gtk_signal_connect (GTK_OBJECT (ldap_settings_item), "activate", GTK_SIGNAL_FUNC(gtk_docklet_menu_cb),
                      GINT_TO_POINTER(3));


    /* show */
    gtk_widget_show_all(GTK_WIDGET(menu));
    gtk_menu_popup(GTK_MENU(menu), NULL, NULL, NULL, NULL, event->button, event->time);

    /* clean up */
    gtk_object_sink(GTK_OBJECT(menu));
    gtk_docklet_toggleIconTrigger(1);
 }

}

/**
* function to toggle trayIcon on call
* is needed because initiator is in another thread and cant modify icon directly
*/
void gtk_docklet_toggleIcon()
{
  if (cIMD.iconLoaded != cIMD.iconWanted)
  {
    if (cIMD.iconLoaded == 2)
    {
      gtk_image_set_from_pixbuf(GTK_IMAGE(cIMD.image), cIMD.pb_scaled);
      //gtk_widget_hide_all(GTK_WIDGET(cIMD.docklet));
      gtk_widget_show_all(GTK_WIDGET(cIMD.docklet));
      cIMD.iconLoaded = 1;
    }
    else if (cIMD.iconLoaded == 1)
    {
      gtk_image_set_from_pixbuf(GTK_IMAGE(cIMD.image), cIMD.pb_scaled2);
      //gtk_widget_hide_all(GTK_WIDGET(cIMD.docklet));
      gtk_widget_show(GTK_WIDGET(cIMD.image));
      //gtk_widget_show_all(GTK_WIDGET(cIMD.docklet));
      cIMD.iconLoaded = 2;
    }
  }
}

/**
* adds given Number (+Name) to recentlines in right-click-menu
*/
bool addRecent(std::string recentLine)
{
  cIMD.recentLines[cIMD._recentCounter] = recentLine;
  cIMD._recentCounter = ++(cIMD._recentCounter) % RECENT_MAX;
  return true;
}

