//$Log: xosddisplay.cpp,v $
//Revision 1.5  2005/01/30 16:59:59  tubsmaster
//now we have ldap support for addressresolution
//
//Revision 1.4  2004/11/17 18:54:47  tubsmaster
//no more console output and font now default xosd font
//
//Revision 1.3  2004/10/20 18:28:36  tubsmaster
//no more warnings..
//
//Revision 1.2  2004/07/05 09:19:00  tubsmaster
//new font, because old helvetica font does not exit in xorg X
//
//Revision 1.1.1.1  2004/06/17 07:17:43  tubsmaster
//initial gtk version
//
//Revision 1.2  2004/06/17 07:12:10  tubsmaster
//longer timeout for xosd
//
//Revision 1.1.1.1  2004/06/05 12:43:28  tubsmaster
//First gtk release
//
//Revision 1.1.1.1  2004/05/21 13:10:42  tubsmaster
//Initial import.
//
//Revision 1.7  2004/05/20 09:15:38  tubsmaster
//add doxygen doc
//

static const char xosdthread_cpp[] = "$Id: xosddisplay.cpp,v 1.5 2005/01/30 16:59:59 tubsmaster Exp $";

#include "xosddisplay.h"

#include <iostream>
#include <string>

/** 
* Class constructor.
* initializes xosd stuff.
*/
xosdDisplay::xosdDisplay()
{
    osd = xosd_create(2);
    if (osd == NULL)
    {
	throw std::string("Could not create \"osd\"");
    }
    xosd_set_font(osd, "-adobe-helvetica-bold-r-normal-*-*-320-*-*-p-*-iso8859-1");
    xosd_set_shadow_offset(osd, 4);
    xosd_set_outline_offset(osd, 2);
    xosd_set_outline_colour(osd, "black");
    xosd_set_pos(osd, XOSD_bottom);
}

/** 
* Class destructor.
* frees from xosd stuff.
*/
xosdDisplay::~xosdDisplay()
{
    xosd_destroy(osd);
}

/** 
* shows the iternal _xosdText for 5 secs as OSD on Screen.
*/
void  xosdDisplay::showLine(std::string line)
{
    xosd_set_timeout(osd,7);
    xosd_display(osd, 0, XOSD_string, line.c_str());
    xosd_show(osd);
}
